/*
 React v16.1.0-beta
 react-test-renderer-shallow.production.min.js

 Copyright (c) 2013-present, Facebook, Inc.

 This source code is licensed under the MIT license found in the
 LICENSE file in the root directory of this source tree.
*/
'use strict';var e=require("object-assign"),f=require("react"),g=require("fbjs/lib/emptyObject"),k=require("prop-types/checkPropTypes");
function l(b){for(var a=arguments.length-1,c="Minified React error #"+b+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant\x3d"+b,d=0;d<a;d++)c+="\x26args[]\x3d"+encodeURIComponent(arguments[d+1]);a=Error(c+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.");a.name="Invariant Violation";a.framesToPop=1;throw a;}function m(b,a){if(!(b instanceof a))throw new TypeError("Cannot call a class as a function");}
var r=function(){function b(){m(this,b);this._rendered=this._newState=this._instance=this._element=this._context=null;this._forcedUpdate=this._rendering=!1;this._updater=new n(this)}b.prototype.getMountedInstance=function(){return this._instance};b.prototype.getRenderOutput=function(){return this._rendered};b.prototype.render=function(a){var c=1<arguments.length&&void 0!==arguments[1]?arguments[1]:g;f.isValidElement(a)?void 0:l("12","function"===typeof a?" Instead of passing a component class, make sure to instantiate it by passing it to React.createElement.":
"");"string"===typeof a.type?l("13",a.type):void 0;if(!this._rendering){this._rendering=!0;this._element=a;this._context=c;if(this._instance)this._updateClassComponent(a.props,c);else{var d=a.type;if(d.prototype&&d.prototype.isReactComponent){this._instance=new a.type(a.props,c,this._updater);if(a.type.hasOwnProperty("contextTypes")){p=a;d=a.type;var b=this._instance;b=b&&b.constructor;k(a.type.contextTypes,c,"context",d.displayName||b&&b.displayName||d.name||b&&b.name||null,q);p=null}this._mountClassComponent(a.props,
c)}else this._rendered=a.type(a.props,c)}this._rendering=!1;return this.getRenderOutput()}};b.prototype.unmount=function(){this._instance&&"function"===typeof this._instance.componentWillUnmount&&this._instance.componentWillUnmount();this._instance=this._rendered=this._newState=this._element=this._context=null};b.prototype._mountClassComponent=function(a,c){this._instance.context=c;this._instance.props=a;this._instance.state=this._instance.state||g;this._instance.updater=this._updater;"function"===
typeof this._instance.componentWillMount&&(a=this._newState,this._instance.componentWillMount(),a!==this._newState&&(this._instance.state=this._newState||g));this._rendered=this._instance.render()};b.prototype._updateClassComponent=function(a,c){this._instance.props!==a&&"function"===typeof this._instance.componentWillReceiveProps&&this._instance.componentWillReceiveProps(a,c);var b=this._newState||this._instance.state||g;"function"!==typeof this._instance.shouldComponentUpdate||!this._forcedUpdate&&
!1!==this._instance.shouldComponentUpdate(a,b,c)?("function"===typeof this._instance.componentWillUpdate&&this._instance.componentWillUpdate(a,b,c),this._instance.context=c,this._instance.props=a,this._instance.state=b,this._rendered=this._instance.render()):(this._instance.context=c,this._instance.props=a,this._instance.state=b,this._forcedUpdate=!1)};return b}();r.createRenderer=function(){return new r};
var n=function(){function b(a){m(this,b);this._renderer=a}b.prototype.isMounted=function(){return!!this._renderer._element};b.prototype.enqueueForceUpdate=function(a,c){this._renderer._forcedUpdate=!0;this._renderer.render(this._renderer._element,this._renderer._context);"function"===typeof c&&c.call(a)};b.prototype.enqueueReplaceState=function(a,c,b){this._renderer._newState=c;this._renderer.render(this._renderer._element,this._renderer._context);"function"===typeof b&&b.call(a)};b.prototype.enqueueSetState=
function(a,b,d){var c=this._renderer._newState||a.state;"function"===typeof b&&(b=b(c,a.props));this._renderer._newState=e({},c,b);this._renderer.render(this._renderer._element,this._renderer._context);"function"===typeof d&&d.call(a)};return b}(),p=null;
function q(){var b="";if(p){var a=null==p?"#empty":"string"===typeof p||"number"===typeof p?"#text":"string"===typeof p.type?p.type:p.type.displayName||p.type.name||"Unknown",c=p._owner,d=p._source,h;if(h=c)c=c.type,h="string"===typeof c?c:"function"===typeof c?c.displayName||c.name:null;c=h;a="\n    in "+(a||"Unknown")+(d?" (at "+d.fileName.replace(/^.*[\\\/]/,"")+":"+d.lineNumber+")":c?" (created by "+c+")":"");b+=a}return b}var t=Object.freeze({default:r}),u=t&&r||t;
module.exports=u["default"]?u["default"]:u;
